//*                                                                             
//*        MA18 TESTJCL                                                         
//*                                                                             
//*   This is a test EXEC for the MA18 SupportPac Rexx/MQ/MVS                   
//*                                                                             
//*   Customise this job by :                                                   
//*                                                                             
//*     * Adding a Job Card                                                     
//*                                                                             
//*     * on the RUN Step change the STEPLIB statement                          
//*              to read                                                        
//*                                                                             
//*           //STEPLIB DD DSN=<your MA18 Loadlib>,DISP=SHR                     
//*           //        DD DSN=<your MQ   loadlib>,DISP=SHR                     
//*                                                                             
//*     * Changing the QManager name on the RXMQV('CONN', 'VRH1')               
//*                    statement                                                
//*                                                                             
//*                                                                             
//*     * You should have Queues N1 and P1 defined in this                      
//*           QM - change the names if required                                 
//*                                                                             
//*                                                                             
//*                                                                             
//LIB      EXEC PGM=IEBGENER                                                    
//*                                                                             
//*            Create the exec library                                          
//*                                                                             
//SYSUT2   DD  DSN=&&LIB(MA18TEST),DISP=(NEW,PASS),                             
//             UNIT=SYSDA,                                                      
//             SPACE=(CYL,(1,1,10)),                                            
//             DCB=(DSORG=PO,RECFM=FB,LRECL=80,BLKSIZE=800)                     
//SYSPRINT DD  DUMMY                                                            
//SYSIN    DD  DUMMY                                                            
//SYSUT1   DD  DATA,DLM='##'                                                    
/* MA18TEST - a Rexx/MQ/MVS Example */                                          
                                                                                
/* Initialise the interface */                                                  
RXMQVTRACE = ''                                                                 
                                                                                
rcc= RXMQV('INIT')                                                              
say 'rc=' rcc                                                                   
                                                                                
/* Connect to Queue Manager - VRH1 */                                           
                                                                                
RXMQVTRACE = ''                                                                 
rcc = RXMQV('CONN', 'VRH1')                                                     
say 'RC=' rcc                                                                   
                                                                                
/* Open Queue N1 for Inquire Access Only, tracing OD accesses */                
                                                                                
iod.on = 'N1'                                                                   
iod.ot = MQOT_Q                                                                 
                                                                                
RXMQVTRACE = 'BOD MOD'                                                          
rcc = RXMQV('OPEN', 'iod.', mqoo_inquire, 'h1', 'ood.')                         
say 'RC=' rcc  'H=' h1                                                          
                                                                                
/* Open Queue P1 for Output and Browse Access, plus Attr manipulation */        
                                                                                
RXMQVTRACE = ''                                                                 
oo = mqoo_inquire+mqoo_output+mqoo_browse+mqoo_set                              
rcc = RXMQV('OPEN', 'P1', oo , 'h2', 'ood.' )                                   
say 'RC=' rcc  'H=' h2                                                          
                                                                                
/* Write a Persistent Message, within UOW, to Queue P1; trace everything */     
                                                                                
RXMQVTRACE = 'PUT BMD MMD MPO BPO'                                              
d.0      = 20                                                                   
d.1      = time() '0123456789'                                                  
imd.PER  = MQPER_PERSISTENT                                                     
ipmo.opt = MQPMO_SYNCPOINT                                                      
rcc      = RXMQV('PUT', h2,'d.','imd.','omd.','ipmo.','opmo.')                  
say 'RC=' rcc                                                                   
                                                                                
/* Inquire upon the number of Messages now in Queue P1 */                       
                                                                                
RXMQVTRACE = ''                                                                 
atrin = mqia_current_q_depth                                                    
atrou = ''                                                                      
rcc   = RXMQV('INQ', h2, atrin, 'atrou' )                                       
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'                                   
                                                                                
/* Show the name of the Queue which is using handle 1*/                         
                                                                                
RXMQVTRACE = ''                                                                 
atrin = mqca_q_name                                                             
atrou = ''                                                                      
rcc   = RXMQV('INQ', h1, atrin, 'atrou' )                                       
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'                                   
/* Toggle the GETtability of a Queue, providing a change each time */           
                                                                                
RXMQVTRACE = ''                                                                 
atrsn = MQIA_INHIBIT_GET                                                        
atrsd = MQQA_GET_INHIBITED                                                      
rcc   = RXMQV('SET', h2, atrsn, atrsd)                                          
say 'RC=' rcc                                                                   
                                                                                
RXMQVTRACE = ''                                                                 
atrin = mqia_inhibit_get ; atrou = ''                                           
rcc   = RXMQV('INQ', h2, atrin, 'atrou' )                                       
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'                                   
                                                                                
RXMQVTRACE = ''                                                                 
atrsn = MQIA_INHIBIT_GET                                                        
atrsd = MQQA_GET_ALLOWED                                                        
rcc   = RXMQV('SET', h2, atrsn, atrsd)                                          
say 'RC=' rcc                                                                   
                                                                                
RXMQVTRACE = ''                                                                 
atrin = MQIA_INHIBIT_GET ; atrou = ''                                           
rcc = RXMQV('INQ', h2, atrin, 'atrou' )                                         
say 'RC=' rcc                                                                   
say 'Atr' atrin 'Setting <'atrou'>'                                             
                                                                                
/* Set the Trigger Data for a Queue ... */                                      
                                                                                
RXMQVTRACE = ''                                                                 
atrsn = MQCA_TRIGGER_DATA                                                       
atrsd = 'RAH Trigger Data'                                                      
rcc   = RXMQV('SET', h2, atrsn, atrsd)                                          
say 'RC=' rcc                                                                   
                                                                                
/* ... and show that it's worked */                                             
                                                                                
RXMQVTRACE = ''                                                                 
atrin = mqca_trigger_data                                                       
atrou = ''                                                                      
rcc = RXMQV('INQ', h2, atrin, 'atrou' )                                         
say 'RC=' rcc 'Atr' atrin 'Setting <'atrou'>'                                   
                                                                                
/* Syncpoint all accesses to the QM */                                          
                                                                                
RXMQVTRACE = ''                                                                 
rcc = RXMQV('CMIT', )                                                           
say 'RC=' rcc                                                                   
                                                                                
/* Browse all msgs on queue P1, tracing everything, showing updates */          
                                                                                
RXMQVTRACE = 'BGO MGO MMD BMD GET'                                              
do i=1                                                                          
   g.0      = 200                                                               
   g.1      = ''                                                                
   igmo.opt = MQGMO_WAIT+MQGMO_BROWSE_NEXT                                      
   rcc = RXMQV('GET',  h2,'g.','igmd.','ogmd.','igmo.','ogmo.')                 
   say 'RC=' rcc                                                                
   say '...............' i 'data <'g.1'> length' g.0                            
   say 'ogmd.pd' ogmd.pd 'ogmo.rqn<'ogmo.rqn'>'                                 
   if ( word(rcc,1) <> 0 ) then leave                                           
   end                                                                          
                                                                                
/* Rollback a Unit of Work (empty in this case) */                              
RXMQVTRACE = ''                                                                 
rcc = RXMQV('BACK', )                                                           
say 'RC=' rcc                                                                   
                                                                                
/* Stop access to a Queue */                                                    
                                                                                
RXMQVTRACE = ''                                                                 
rcc = RXMQV('CLOSE', h2, mqco_none)                                             
say 'RC=' rcc                                                                   
                                                                                
/* Re-open the P1 Queue for Browse only access */                               
                                                                                
RXMQVTRACE = ''                                                                 
rcc = RXMQV('OPEN', 'P1', mqoo_browse, 'h3', 'ood.')                            
say 'RC=' rcc  'H=' h3                                                          
                                                                                
/* Browse the Queue using the Extension function */                             
RXMQVTRACE = ''                                                                 
do i=1                                                                          
   g.0 = 200                                                                    
   g.1 = ''                                                                     
   rcc = RXMQV('BROWSE',  h3,'g.')                                              
   say 'RC=' rcc                                                                
   say '@@@@@@@@@@@@@@@' i 'data <'g.1'> length' g.0                            
   if ( word(rcc,1) <> 0 ) then leave                                           
   end                                                                          
                                                                                
/* Show the last command used etc. */                                           
say 'Last Message <'RXMQV.LASTMSG'> Last call 'RXMQV.LASTOP,                    
    ' which ended with RC' RXMQV.LASTRC') and MQCC' RXMQV.LASTCC')',            
    ' MQRC' RXMQV.LASTAC')'                                                     
                                                                                
                                                                                
/* Issue a Bad command to show effect of -ve RC */                              
rcc = RXMQV('OPEN', )                                                           
say 'Last Message <'RXMQV.LASTMSG'> Last call 'RXMQV.LASTOP,                    
    ' which ended with RC' RXMQV.LASTRC') and MQCC' RXMQV.LASTCC')',            
    ' MQRC' RXMQV.LASTAC')'                                                     
                                                                                
/* Stop access to the Queue */                                                  
                                                                                
RXMQVTRACE = ''                                                                 
rcc = RXMQV('CLOSE', h3, mqco_none)                                             
say 'RC=' rcc                                                                   
                                                                                
/* Disconnect from the QM (Closing h1 in the process) */                        
                                                                                
RXMQVTRACE = ''                                                                 
rcc = RXMQV('DISC', )                                                           
say 'RC=' rcc                                                                   
                                                                                
/* Remove the Interface functions from the Rexx Workspace ... */                
                                                                                
RXMQVTRACE = 'TERM'                                                             
rcc = RXMQV('TERM', )                                                           
say 'RC=' rcc                                                                   
                                                                                
/* ... but leave the MQ_ constants around */                                    
say 'MQPER_PERSISTENT' MQPER_PERSISTENT 'RC(2048) is' RXMQV.RCMAP.2048          
                                                                                
/* End of MA18TEST exec */                                                      
##                                                                              
/*                                                                              
//RUN      EXEC PGM=IKJEFT01                                                    
//SYSPROC  DD  DSN=&&LIB,DISP=SHR                                               
//STEPLIB  DD  DSN=RHARRI1.MA18LOAD,DISP=SHR                                    
//         DD  DSN=RHARRI1.CSQ.LOAD,DISP=SHR                                    
//SYSPRINT DD  SYSOUT=*                                                         
//SYSUDUMP DD  SYSOUT=*                                                         
//SYSTSPRT DD  SYSOUT=*,DCB=(RECFM=F,LRECL=132,BLKSIZE=132)                     
//SYSTSIN  DD  *                                                                
MA18TEST                                                                        
/*                                                                              
//*                                                                             
//*  PS: The following steps were performed by:                                 
//*                                                                             
//*       @  the Author (WINMVC.HARRISR, HARRISR@VNET.IBM.COM)                  
//*                                                                             
//*       =  yourself                                                           
//*                                                                             
//*      to get this test exec working                                          
//*                                                                             
//*   To Upload the Load Module                                                 
//*   -------------------------                                                 
//*                                                                             
//* @  TSO:   xmit ssssssss.uuuuuuu dsn(my load library)                        
//* @                               member(RXMQV)                               
//* @                               outdsn(ma18seqx)                            
//* @                                                                           
//* @  OS/2:  receive ma18seq a:ma18seqx                                        
//* @                                                                           
//* @         infozip MA18.zip ma18seq                                          
//* @                                                                           
//*                                                                             
//* =  OS/2:  infozip a:ma18.zip                                                
//* =                                                                           
//* =         send ma18seq a:ma18seq                                            
//* =                                                                           
//* =  TSO:   receive indsn(ma18seq)                                            
//* =                 -> dsn(ma18load)                                          
//* =                                                                           
//* =         ISPF 3.3.Copy from(ma18load(*)) to(your load library)             
//* =                                                                           
//* =                                                                           
//*   To Upload this JCL                                                        
//*   ------------------                                                        
//*                                                                             
//* =  OS/2:  infozip a:ma18.zip                                                
//* =                                                                           
//* =         send ma18test.jcl a:ma18test ascii crlf recfm(f)                  
//* =                                                                           
//* =                                                                           
//* =                                                                           
//* =                                                                           
//*                                                                             
//*                                                                             
//                                                                              
